/*
 * Copyright 2011 ArcBees Inc.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

package com.arcbees.facebook.client.event;

import com.google.gwt.event.shared.EventHandler;
import com.google.gwt.event.shared.GwtEvent;
import com.google.gwt.event.shared.HasHandlers;

public class FacebookLoadedEvent extends GwtEvent<FacebookLoadedEvent.FacebookLoadedHandler> {
  public static Type<FacebookLoadedHandler> TYPE = new Type<FacebookLoadedHandler>();

  public interface FacebookLoadedHandler extends EventHandler {
    void onFacebookLoaded(FacebookLoadedEvent event);
  }

  @Override
  protected void dispatch(FacebookLoadedHandler handler) {
    handler.onFacebookLoaded(this);
  }

  @Override
  public Type<FacebookLoadedHandler> getAssociatedType() {
    return TYPE;
  }

  public static Type<FacebookLoadedHandler> getType() {
    return TYPE;
  }

  public static void fire(HasHandlers source) {
    source.fireEvent(new FacebookLoadedEvent());
  }
}
